diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index 9df34cb76..315461b50 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -25,11 +25,6 @@ public class BlockLogicFence
         super(block, Materials.WOOD);
     }
 
-    @Override
-    public boolean canPlaceOnSurface() {
-        return true;
-    }
-
     @Override
     public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (side.isVertical()) {
@@ -89,8 +84,8 @@ public class BlockLogicFence
 
     public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         TilePos queryPos = new TilePos();
-        final @NotNull Block<?> b = source.getBlockType(tilePos.add(side.getDirection(), queryPos));
-        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite();
+        final @NotNull Block<?> b = source.getBlockType(tilePos.add(side.direction(), queryPos));
+        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || b.getAttachedSide(source, tilePos.add(side.direction(), queryPos)) == side.opposite();
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
index 072597a2c..806039014 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
@@ -18,8 +18,8 @@ public class BlockLogicFenceChainlink extends BlockLogicFenceThin {
     @Override
     public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         TilePos queryPos = new TilePos();
-        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.getDirection(), queryPos));
-        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
+        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.direction(), queryPos));
+        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.direction(), queryPos)) == side.opposite());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index c74ebaa0f..eefc919c8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -74,7 +74,7 @@ public class BlockLogicFenceGate
 
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
-        final int direction = mob.getHorizontalPlacementDirection(side).getHorizontalIndex();
+        final int direction = mob.getHorizontalPlacementDirection(side).legacyHorizontalIndex();
         final int meta = world.getBlockData(tilePos);
         world.setBlockDataNotify(tilePos, direction | (meta & ~MASK_DIRECTION));
     }
@@ -84,7 +84,7 @@ public class BlockLogicFenceGate
         if (!side.isHorizontal()) {
             side = Side.NORTH;
         }
-        final int direction = side.getDirection().getHorizontalIndex();
+        final int direction = side.direction().legacyHorizontalIndex();
         final int meta = world.getBlockData(tilePos);
         world.setBlockDataNotify(tilePos, direction | (meta & ~MASK_DIRECTION));
     }
@@ -134,7 +134,7 @@ public class BlockLogicFenceGate
 
     @Override
     public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
-        this.onInteracted(world, tilePos, null, direction.getSide(), 0.5, 0.5);
+        this.onInteracted(world, tilePos, null, direction.side(), 0.5, 0.5);
     }
 
     public static boolean isOpen(final int meta) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
index 1493510e1..cdc450111 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
@@ -18,7 +18,7 @@ public class BlockLogicFenceSteel
     @Override
     public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         TilePos queryPos = new TilePos();
-        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.getDirection(), queryPos));
-        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
+        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.direction(), queryPos));
+        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.direction(), queryPos)) == side.opposite());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
index 14058f6be..1613ad4f4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
@@ -21,11 +21,6 @@ public abstract class BlockLogicFenceThin
         super(block, material);
     }
 
-    @Override
-    public boolean canPlaceOnSurface() {
-        return true;
-    }
-
     @Override
     public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (side.isVertical()) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
index a4c258f97..a1655ba49 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
@@ -18,7 +18,7 @@ public class BlockLogicFenceWallPaper
     @Override
     public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         TilePos queryPos = new TilePos();
-        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.getDirection(), queryPos));
-        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
+        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.direction(), queryPos));
+        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.direction(), queryPos)) == side.opposite());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index 5a927c736..55dd2555a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -69,7 +69,7 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
                 } else {
                     world.setBlockDataNotify(tilePos, localFlowDecay);
                     world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
-                    world.notifyBlocksOfNeighborChange(tilePos, this.block); // ?
+                    world.notifyBlocksOfNeighborChange(tilePos, this.block);
                 }
             } else {
                 setFluidStill(world, tilePos);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
index 3d67c7024..2313016d4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
@@ -16,20 +16,20 @@ public class BlockLogicFullyRotatable extends BlockLogic {
 
     @Override
     public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
-        final Direction direction = mob.getPlacementDirection(side).getOpposite();
+        final Direction direction = mob.getPlacementDirection(side).opposite();
         world.setBlockDataNotify(tilePos, directionToMeta(direction));
     }
 
     @Override
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
-        world.setBlockDataNotify(tilePos, directionToMeta(side.getDirection()));
+        world.setBlockDataNotify(tilePos, directionToMeta(side.direction()));
     }
 
     public static int directionToMeta(Direction direction) {
-        return direction.getId() & MASK_DIRECTION;
+        return direction.id;
     }
 
     public static @NotNull Direction metaToDirection(final int data) {
-        return Direction.getDirectionById(data & MASK_DIRECTION);
+        return Direction.fromId(data & MASK_DIRECTION);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index 7969695e9..3d43989b9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -78,7 +78,7 @@ public class BlockLogicLadder extends BlockLogic implements ISupportable {
     public @Nullable Side getSideForPlacement(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side clickedSide) {
         TilePosc p = tilePos;
         if (!world.canPlaceInsideBlock(tilePos)) {
-            p = p.add(clickedSide.getDirection(), new TilePos());
+            p = p.add(clickedSide.direction(), new TilePos());
         }
 
         if (canExistAt(world, p, getMetaForSide(clickedSide))) return clickedSide;
@@ -91,7 +91,7 @@ public class BlockLogicLadder extends BlockLogic implements ISupportable {
     }
 
     public boolean canExistAt(@NotNull World world, @NotNull TilePosc tilePos, int meta) {
-        Side side = getSideFromMeta(meta).getOpposite();
+        Side side = getSideFromMeta(meta).opposite();
         return isSupported(world, tilePos, side);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
index 06b608fd0..64492b0b8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
@@ -25,8 +25,7 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
         int myMetadata = world.getBlockData(tilePos);
         if (myMetadata == 0x7) return;
 
-        for (int i = 0; i < Direction.horizontalDirections.length; i++) {
-            Direction dir = Direction.horizontalDirections[i];
+        for (final var dir : Direction.horizontal) {
             TilePos dirPos = tilePos.add(dir, new TilePos());
             if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockType(dirPos) == this.block && world.getBlockData(dirPos) >= myMetadata))) return;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index 52b510ea7..07cc209bc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -35,8 +35,8 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase {
         int myMetadata = world.getBlockData(tilePos);
         if (myMetadata == 0x7) return;
 
-        for (int i = 0; i < Direction.horizontalDirections.length; i++) {
-            TilePos p = tilePos.add(Direction.horizontalDirections[i], new TilePos());
+        for (final var dir : Direction.horizontal) {
+            TilePos p = tilePos.add(dir, new TilePos());
 
             if (!((world.isBlockOpaqueCube(p)) || (world.getBlockType(p) == this.block && world.getBlockData(p) >= myMetadata))) {
                 return;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index c4d25e101..a853eafd6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -32,8 +32,7 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase {
         int myMetadata = world.getBlockData(tilePos);
         if (myMetadata == 0x7) return;
 
-        for (int i = 0; i < Direction.horizontalDirections.length; i++) {
-            Direction dir = Direction.horizontalDirections[i];
+        for (final var dir : Direction.horizontal) {
             TilePos dirPos = tilePos.add(dir, new TilePos());
             if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockType(dirPos) == this.block && world.getBlockData(dirPos) >= myMetadata)))
                 return;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
index d0a5d984c..b14ad73dd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
@@ -61,7 +61,7 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
 
     @Override
     public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
-        Side checkSide = side.getOpposite();
+        Side checkSide = side.opposite();
         return isSupported(world, tilePos, checkSide);
     }
 
@@ -84,12 +84,12 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
         switch (side) {
             case BOTTOM:
                 if (isSupported(world, tilePos, Side.TOP)) {
-                    rotation = ROTATION_BOTTOM_NS + (mob.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
+                    rotation = ROTATION_BOTTOM_NS + (mob.getHorizontalPlacementDirection(side).axis() == Axis.Z ? 1 : 0);
                 }
                 break;
             case TOP:
                 if (isSupported(world, tilePos, Side.BOTTOM)) {
-                    rotation = ROTATION_TOP_NS + (mob.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
+                    rotation = ROTATION_TOP_NS + (mob.getHorizontalPlacementDirection(side).axis() == Axis.Z ? 1 : 0);
                 }
                 break;
             case NORTH:
@@ -127,7 +127,7 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
         int meta = world.getBlockData(tilePos);
         boolean isPowered = isPowered(meta);
         int rotation = -1;
-        switch (side.getOpposite()) {
+        switch (side.opposite()) {
             case BOTTOM -> {
                 if (isSupported(world, tilePos, Side.TOP)) {
                     rotation = ROTATION_BOTTOM_NS;
@@ -226,29 +226,31 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
         return true;
     }
 
+    private static @NotNull Direction getDirection(int rotation) {
+        return switch (rotation) {
+            default -> Direction.NONE;
+            case ROTATION_EAST -> Direction.WEST;
+            case ROTATION_WEST -> Direction.EAST;
+            case ROTATION_SOUTH -> Direction.NORTH;
+            case ROTATION_NORTH -> Direction.SOUTH;
+            case ROTATION_TOP_NS, ROTATION_TOP_WE -> Direction.DOWN;
+            case ROTATION_BOTTOM_NS, ROTATION_BOTTOM_WE -> Direction.UP;
+        };
+    }
+
     public void flip(@NotNull World world, @NotNull TilePosc tilePos, @Nullable Player player) {
         int meta = world.getBlockData(tilePos);
         int rotation = getRotation(meta);
         if (isPowered(meta)) {
-            world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
+            world.setBlockData(tilePos, meta & ~MASK_POWERED);
         } else {
-            world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
+            world.setBlockData(tilePos, meta | MASK_POWERED);
         }
 
-        world.markBlocksDirty(tilePos, tilePos);
+        world.markBlockNeedsUpdate(tilePos);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, isPowered(meta) ? 0.5F : 0.6F);
-        world.notifyBlocksOfNeighborChange(tilePos, this.block);
 
-        TilePos queryPos = new TilePos();
-        switch (rotation) {
-            case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block);
-            case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block);
-            case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block);
-            case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block);
-            case ROTATION_TOP_NS, ROTATION_TOP_WE ->
-                world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
-            default -> world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
-        }
+        world.notifyBlocksInCapsuleOfNeighborChange(getDirection(rotation), tilePos, this.block);
     }
 
     @Override
@@ -259,18 +261,8 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
     @Override
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         if (isPowered(data)) {
-            world.notifyBlocksOfNeighborChange(tilePos, this.block);
-            TilePos queryPos = new TilePos();
             int rotation = getRotation(data);
-            switch (rotation) {
-                case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block);
-                case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block);
-                case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block);
-                case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block);
-                case ROTATION_TOP_NS, ROTATION_TOP_WE ->
-                    world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
-                default -> world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
-            }
+            world.notifyBlocksInCapsuleOfNeighborChange(getDirection(rotation), tilePos, this.block);
         }
         super.onRemoved(world, tilePos, data);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
index 33229309b..448ef8f85 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
@@ -52,7 +52,7 @@ public class BlockLogicMagma extends BlockLogic {
     public boolean canMelt(@NotNull World world, @NotNull TilePosc tilePos) {
         boolean canMelt = false;
         TilePos queryPos = new TilePos();
-        for (Direction dir : Direction.directions) {
+        for (final var dir : Direction.all) {
             Block<?> block = world.getBlockType(tilePos.add(dir, queryPos));
             Material adjacentMaterial = block == null ? Materials.AIR : block.getMaterial();
             if (adjacentMaterial == Materials.WATER) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
index 639ef05cc..d247ec354 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
@@ -42,7 +42,7 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
 
     @Override
     public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
-        Axis axis = mob.getPlacementDirection(side, PlacementMode.FACING).getAxis();
+        Axis axis = mob.getPlacementDirection(side, PlacementMode.FACING).axis();
 
         world.setBlockDataNotify(tilePos, axisToMeta(axis));
         world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
@@ -111,7 +111,7 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
 
     @Override
     public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
-        return this.isActive && (BlockLogicAxisAligned.metaToAxis(source.getBlockData(tilePos)) != side.getAxis());
+        return this.isActive && (BlockLogicAxisAligned.metaToAxis(source.getBlockData(tilePos)) != side.axis());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
index 99ea73638..e413fb88e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
@@ -23,12 +23,6 @@ public class BlockLogicMesh extends BlockLogicTransparent
         return false;
     }
 
-    @Override
-    public boolean canPlaceOnSurface()
-    {
-        return true;
-    }
-
     @Override
     public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePosc tilePos) {
         return !(entity instanceof EntityItem);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
index e2058485e..1792e738d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
@@ -23,12 +23,6 @@ public class BlockLogicMobSpawnerDeactivated extends BlockLogicTransparent {
         return false;
     }
 
-    @Override
-    public boolean canPlaceOnSurface()
-    {
-        return true;
-    }
-
     @Override
     public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePosc tilePos) {
         return !(entity instanceof EntityItem);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index 54cd8e48f..3e0fc96f6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -36,7 +36,7 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
 
         if (world.areBlocksLoaded(tilePos, 16)) {
             if (rand.nextInt(20) == 0 && airExposed(world, tilePos)) {
-                Direction rDir = Direction.getDirectionById(rand.nextInt(6));
+                Direction rDir = Direction.ID_MAP[rand.nextInt(6)];
                 TilePos randomPos = tilePos.add(rDir, new TilePos());
                 if (canMossSpread(world, randomPos)) {
                     @Nullable Block<?> mossStone = getMossBlock(world.getBlockType(randomPos));
@@ -54,8 +54,7 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
         int maxBlockLight = 0;
         int maxSkyLight = 0;
         TilePos queryPos = new TilePos();
-        for (int i = 0; i < Direction.directions.length; i++) {
-            Direction dir = Direction.directions[i];
+        for (final var dir : Direction.all) {
             TilePos offsetPos = tilePos.add(dir, queryPos);
             int blockLight = world.getBlockLightValue(offsetPos);
             int skyLight = world.getSavedLightValue(LightLayer.Sky, offsetPos);
@@ -134,8 +133,7 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
 
     public boolean airExposed(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        for (int i = 0; i < Direction.directions.length; i++) {
-            Direction dir = Direction.directions[i];
+        for (final var dir : Direction.all) {
             if (world.isAirBlock(tilePos.add(dir, queryPos))) return true;
         }
         return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
index 7b2c23008..794d81e3e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
@@ -35,8 +35,7 @@ public class BlockLogicMotionSensor extends BlockLogicVeryRotatable {
         TilePos queryPos = new TilePos();
         final int brightness = 10;
         double d = 0.0625;
-        for (int i = 0; i < Direction.directions.length; i++) {
-            Direction dir = Direction.directions[i];
+        for (final var dir : Direction.all) {
             double px = (double) tilePos.x() + rand.nextFloat();
             double py = (double) tilePos.y() + rand.nextFloat();
             double pz = (double) tilePos.z() + rand.nextFloat();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
index 8e9237aae..28070ac04 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
@@ -111,8 +111,7 @@ public class BlockLogicOreRedstone extends BlockLogic {
 
         final double d = 0.0625;
         TilePos queryPos = new TilePos();
-        for (int i = 0; i < Direction.directions.length; i++) {
-            Direction dir = Direction.directions[i];
+        for (final var dir : Direction.all) {
             double px = (double) tilePos.x() + random.nextFloat();
             double py = (double) tilePos.y() + random.nextFloat();
             double pz = (double) tilePos.z() + random.nextFloat();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
index c9032d5f7..abacf19c0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
@@ -2,7 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -16,7 +18,9 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicOverlayPebbles extends BlockLogic {
+public class BlockLogicOverlayPebbles extends BlockLogic
+    implements ISupportable
+{
     public static final int MAX_PEBBLES = 3;
     public static final int MASK_PEBBLE_AMOUNT = 0b0000_0011;
     public BlockLogicOverlayPebbles(@NotNull Block<?> block, @NotNull Material material) {
@@ -37,8 +41,7 @@ public class BlockLogicOverlayPebbles extends BlockLogic {
 
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
-        Block<?> block = world.getBlockType(tilePos.down(new TilePos()));
-        return block.getMaterial().isSolid();
+        return this.isSupported(world, tilePos, Side.BOTTOM);
     }
 
     @Override
@@ -89,4 +92,9 @@ public class BlockLogicOverlayPebbles extends BlockLogic {
     public static int getStackCount(int data) {
         return data & MASK_PEBBLE_AMOUNT;
     }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return FullSupport.INSTANCE;
+    }
 }
